#ifndef INCLUDE_COMMON_DEFINES_H
#define INCLUDE_COMMON_DEFINES_H
#define BUFFERS 6 //1 //6
#define RET_SUCCESS 0
#define RET_FAILURE 1 
#include <ffmpeg/avcodec.h>
#include <ffmpeg/avformat.h>




enum Covit_PixelFmt {
	COVIT_PIX_FMT_NONE= -1, 
	COVIT_PIX_FMT_YUV420,
	COVIT_PIX_FMT_YUV422,
	COVIT_PIX_FMT_RGB32,
	COVIT_PIX_FMT_RGB24,
	COVIT_PIX_FMT_BGR
};

#define COVIT_PIX_FMT_YUYV COVIT_PIX_FMT_YUV422


typedef struct encodeformat
{
	CodecID encode_fmt;
	int encode_width;
	int encode_height;
	int encode_bitrate;
	int fps;
	int gopSize;
	
};

typedef struct decodeformat
{
	CodecID decode_fmt;
	int decode_width;
	int decode_height;
	
};


typedef struct capNode
{
	int id;
	pthread_mutex_t capthr_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t  capthr_cond; //  = PTHREAD_COND_INITIALIZER;
	pthread_mutex_t capstop_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t  capstop_cond; //  = PTHREAD_COND_INITIALIZER;
	pthread_mutex_t capstatus_mutex;
	int stopCapStatus;
	encodeformat encodeFmtNode;
};

typedef struct sendNode
{
	int id;
	
	pthread_mutex_t sendthr_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t  sendthr_cond; //  = PTHREAD_COND_INITIALIZER;

	pthread_mutex_t sendstop_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t sendstop_cond; //  = PTHREAD_COND_INITIALIZER;
	pthread_mutex_t sendstatus_mutex;
	int send_quit;
	 
};

typedef struct recvNode
{
	int id;

	pthread_mutex_t recvthr_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t  recvthr_cond; //  = PTHREAD_COND_INITIALIZER;

	pthread_mutex_t recvstop_cond_mutex; // = PTHREAD_MUTEX_INITIALIZER;
	pthread_cond_t  recvstop_cond; //  = PTHREAD_COND_INITIALIZER;
	int recv_quit;
	decodeformat decodeFmtNode;
};




#endif
