

#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>

#include <iostream>
#include <string.h>
#include <SDL/SDL.h>
#include <SDL/SDL_thread.h>
using namespace std;
#include "common_defines.h"
#include "unicapVidCap.h"

#define UYVY 0x59565955 /* UYVY (packed, 16 bits) */
#define FOURCC(a,b,c,d) (unsigned int)((((unsigned int)d)<<24)+(((unsigned int)c)<<16)+(((unsigned int)b)<<8)+a)

extern pthread_mutex_t capstatus_mutex;

CCameraDevice* CCameraDevice::m_CameraInstance = NULL; 
CUnicapVidCap* CUnicapVidCap::m_instance = NULL;
unicap_format_t format;
pthread_mutex_t g_CapBuffer =  PTHREAD_MUTEX_INITIALIZER;

int initformat()
{
	format.size.height = 320;
	format.size.height = 240;


	return 0;
}

int setCameraResolution(int ht, int width)
{
	format.size.height = ht;
	format.size.height = width;

	return 0;
};


int CCameraDevice::getNumberofCams()
{
	int i;
	unicap_device_t device;
	for( i = 0; SUCCESS(unicap_enumerate_devices(NULL,&device, i)); i++)
	{
		cout << i << " : " << device.identifier << endl ;
	}
	
	return i;	

};

void CCameraDevice::stop_capture()
{
	for(int i = 0; i < m_NumCams; i++)
	{

		if(!SUCCESS(unicap_stop_capture(m_handle[i])))
		{
			cout << "Failed to stop Capture on device : " << endl;
		
		}
		if(!SUCCESS(unicap_close(m_handle[i])))
		{
			cout << "Failed to close device : " << endl;
		}
		m_handle[i] = NULL;
		m_start_capture[i] = 0;
		
		for(int k = 0; k < BUFFERS; k++)
		{	
			free(m_buffers[i][k].data);
		}
	}

};


void CCameraDevice::deinitCams()
{
	m_NumCams = 0;
	stop_capture();
	free(m_hndRefCount);
	free(m_handle);
	free(m_device);
	free(m_format_spec);
	free(m_format);
};

int CCameraDevice::initCamera()
{
	m_NumCams = getNumberofCams();
	m_handle = (unicap_handle_t *)malloc(m_NumCams* sizeof(unicap_handle_t));
	m_device = (unicap_device_t *)malloc(m_NumCams* sizeof(unicap_device_t));
	m_format_spec = (unicap_format_t *)malloc(m_NumCams* sizeof(unicap_format_t));
	m_format = (unicap_format_t *)malloc(m_NumCams* sizeof(unicap_format_t));
	m_start_capture = (int *)malloc(m_NumCams* sizeof(int));
	m_hndRefCount = (int *)malloc(m_NumCams* sizeof(int));	
	m_buffers = (unicap_data_buffer_t **)malloc(m_NumCams* sizeof(unicap_data_buffer_t *));	
	
	for(int i = 0; i < m_NumCams; i++)
	{
		m_handle[i] = NULL;
		m_start_capture[i] = 0;
		m_hndRefCount[i] = 0;
		m_buffers[i] = (unicap_data_buffer_t *)malloc(BUFFERS * sizeof(unicap_data_buffer_t));	
		for(int k = 0; k < BUFFERS; k++)
		{
			memset(&m_buffers[i][k], 0x0, sizeof(unicap_data_buffer_t));
			m_buffers[i][k].buffer_size = 0;
			m_buffers[i][k].data = NULL;

		}
		unicap_void_format(& m_format_spec[i]);
		unicap_void_format(& m_format[i]);		

	}
	return 0;

};

int CCameraDevice::start_capture(int device_no)
{
	
	
	if(m_start_capture[device_no] ==  0)
	{
		cout << "start capture on device : " << endl;	
		if(!SUCCESS(unicap_start_capture(m_handle[device_no])))
		{
			cout << "Failed to start capture on device : " << m_device[device_no].identifier << endl;
			exit(1);
		}
		int i = 0;
		for(i = 0; i < BUFFERS; i++)
		{ 
			unicap_queue_buffer(m_handle[device_no], &m_buffers[device_no][i]);
			
		}
		m_start_capture[device_no] = 1;
	}
	else
	{
		cout << "capture on device Running : " << endl;
	}		

	return 0;
}
	
int CCameraDevice::setformats(int device_no, unicap_format_t *format)
{
	
	int dno = device_no;
	//unicap_void_format(&m_format_spec[dno]);
	
	int i = 0;
		
	m_format_spec[dno].fourcc = FOURCC("U","Y","V","Y");

	for(i = 0; SUCCESS(unicap_enumerate_formats(m_handle[dno], NULL, &m_format[dno], i)); i++)
	{		
		cout << i << ": " << m_format[dno].identifier << " " << m_format[dno].bpp << " " << m_format[dno].size.height << " " << endl;
	}
	

	if( --i > 0)
	{
		cout << "Select video Format : " ;
		cin >> i ;		
	}
	if(!SUCCESS(unicap_enumerate_formats(m_handle[dno],NULL, &m_format[dno], i)))
	{
		cout << "Failed to get video format" << endl;
	
		exit(1);
	}	

	for(i = 0; i < BUFFERS; i++)
	{
		if(m_buffers[dno][i].data != NULL)
		{
			free(m_buffers[dno][i].data);	
			memset(&m_buffers[dno][i], 0x0, sizeof(unicap_data_buffer_t));
			m_buffers[dno][i].buffer_size = 0;
		
		}
	
		memset(&m_buffers[dno][i], 0x0, sizeof(unicap_data_buffer_t));
		m_buffers[dno][i].buffer_size = m_format[dno].size.width* m_format[dno].size.height * (m_format[dno].bpp / 8);
		m_buffers[dno][i].data = (unsigned char *)malloc(m_buffers[dno][i].buffer_size);
	}
	
	*format = m_format[dno];
	return 0;
};

int CCameraDevice::closeCamHandle(int device_no)
{
	m_hndRefCount[device_no]--;

	cout << "device_no " << device_no << "m_hndRefCount[device_no] " << m_hndRefCount[device_no] <<endl;  
	if(m_hndRefCount[device_no] == 0)	
	{
		if(!SUCCESS(unicap_stop_capture(m_handle[device_no])))
		{
			cout << "Failed to stop Capture on device : " << endl;
		
		}
		if(!SUCCESS(unicap_close(m_handle[device_no])))
		{
			cout << "Failed to close device : " << endl;
		}
		//unicap_close(*handle);
	}
	return 0;
	
};
int CCameraDevice::getCamHandle(unicap_handle_t *handle, int device_no)
{
	int i = device_no;
	if(m_handle[i] == NULL)
	{

		if(!SUCCESS(unicap_enumerate_devices(NULL, &m_device[i], i)))
		{
			cout << "Error : failed to get info for device : "<< m_device[i].identifier << endl ; 
			exit(1);
		}
		if(!SUCCESS(unicap_open(&m_handle[i], &m_device[i])))
		{
			cout << "Error : failed to open device : "<< m_device[i].identifier << endl ; 
			exit(1);
		}
		else
		{
			cout << "Opened Video Capture Device : "<< m_device[i].identifier << endl ; 	
			//handle = &m_handle[i];
		}
		
		unicap_void_format(&m_format_spec[i]);
		m_format_spec[i].fourcc = FOURCC("U","Y","V","Y");
		
		if(format.size.height != 0)
		{	
			m_format[i].size.width = format.size.width;
			m_format[i].size.height = format.size.height;
		}

		if(!SUCCESS(unicap_enumerate_formats(m_handle[i], NULL, &m_format[i], i) ))
		{		
			cout << i << ": " << m_format[device_no].identifier << " " << m_format[device_no].bpp << " " << m_format[device_no].size.height << " " << endl;
		}
		m_hndRefCount[i]++;
		*handle = m_handle[i];
		
	}
	else
	{
		*handle = m_handle[i];
		m_hndRefCount[i]++;
	}

	return 0;
};

CCameraDevice::CCameraDevice()
{
	m_refCount = 0;
	m_NumCams = 0;
	m_hndRefCount = NULL;
	m_handle = NULL;
	m_device = NULL;
	m_format_spec = NULL;
	m_format = NULL;
	m_buffers = NULL;
	initCamera();

};

CCameraDevice::~CCameraDevice()
{
	cout << "destructor Camera" << endl;
	deinitCams();	
	m_CameraInstance = NULL;
	SDL_Quit();
};

void CCameraDevice::destroy() 
{ 
	m_refCount--;
	cout << "m_refCount "<< m_refCount << endl;
	if(m_refCount == 0)
		delete m_CameraInstance;
};


CCameraDevice* CCameraDevice::Instance()
{
	
	if(m_CameraInstance == NULL)
	{	
		m_CameraInstance = new CCameraDevice();
		m_CameraInstance->m_refCount++;
		return m_CameraInstance;

	}	
	m_CameraInstance->m_refCount++;
	return m_CameraInstance; 

};


CUnicapVidCap::CUnicapVidCap(IVideoCapture *ptr, int threadid)
{

	BaseVidCapture = (IVideoCapture *)ptr;	
	m_returned_buffer = NULL;
	m_PixFmt = 0;
	format.size.height = 0;
	format.size.height = 0;
	m_threadid = threadid;
	m_device_no = -1;

	for(int i = 0; i < BUFFERS; i++)
	{
		memset(&m_buffers[i], 0x0, sizeof(unicap_data_buffer_t));
		m_buffers[i].buffer_size = 0;
		m_buffers[i].data = NULL;
	}
	m_Cam = CCameraDevice::Instance();

};

CUnicapVidCap::~CUnicapVidCap()
{
	m_instance = NULL;
	m_returned_buffer = NULL;
	
	for(int i = 0; i < BUFFERS; i++)
	{
		if(m_buffers[i].data != NULL)
		{
			free(m_buffers[i].data);	
			memset(&m_buffers[i], 0x0, sizeof(unicap_data_buffer_t));
			m_buffers[i].buffer_size = 0;
		}
	}
	m_Cam->destroy();
};	
/*
CUnicapVidCap* CUnicapVidCap::Instance(IVideoCapture *ptr, int threadid)
{
	if(m_instance == 0)
	{	
		m_instance = new CUnicapVidCap(ptr, threadid);

		

	}	
	return m_instance; 
};

void CUnicapVidCap::destroy() 
{ 
	delete m_instance;
};
*/

void CUnicapVidCap::open_device(int i)
{
	m_Cam->getCamHandle(&m_handle, i);
	m_device_no = i;	
};

int CUnicapVidCap::enumerate_devices()
{ 
	return m_Cam->getNumberofCams();
};	

void CUnicapVidCap::setformats()
{
//	m_format_spec.fourcc = FOURCC("U","Y","V","Y");
//	m_format.size.width = 320;
//	m_format.size.height = 240;

	m_Cam->setformats(m_device_no, &m_format);	
	if(FOURCC("Y","U","Y","V") == m_format.fourcc) 
	{
		m_PixFmt = COVIT_PIX_FMT_YUV422;
		cout << "Format found" << endl;
	}		

	return;
			

};

void CUnicapVidCap::start_capture(int *stopCapStatus, int fps)
{
	int i = 0;
	m_Cam->start_capture(m_device_no);
	
	cout << m_format.size.width << " S " << m_format.size.height << endl;	

	
	int frame = 0;
	struct timeval prev,current, present;
	prev.tv_sec = current.tv_sec = prev.tv_usec = current.tv_usec = 0;
	int ts_fps = 0;
	int ts_usec = 0;
	pthread_mutex_lock( m_capstatus_mutex );
	while(!(*stopCapStatus))
	{
		
		pthread_mutex_unlock( m_capstatus_mutex );
		
		int buffers_ready;
		
		
		pthread_mutex_lock( &g_CapBuffer );
		if(!SUCCESS(unicap_poll_buffer(m_handle, &buffers_ready)))
		{
			buffers_ready = 1;
		}

		for(i = 0; i < buffers_ready; i++)
		{
		
			if(!SUCCESS(unicap_wait_buffer(m_handle, &m_returned_buffer)))
			{
				cout << "Failed to wait for buffer" << endl;
				exit(1);
			}
			
			IVideoCapture::print_fps();
			if(frame == 0)
			{
				gettimeofday(&prev, NULL);

			}
			else
			{
				gettimeofday(&current, NULL);
				ts_usec = (current.tv_sec * 1000000 + current.tv_usec) - (prev.tv_sec * 1000000 + prev.tv_usec)	;			
				prev = current;

			}
			
			BaseVidCapture->Process_Raw_Video( buffers_ready-i,m_PixFmt, 0,  m_format.size.width/2, m_format.size.height/2,m_returned_buffer->data, ts_usec);


//Enable to display the captured raw Video in a Window				
#if 0
			{
				AVFrame *pFrame, *pFrameRGB;
				 // Register all formats and codecs
				av_register_all();
				pFrame = avcodec_alloc_frame();
				pFrameRGB = avcodec_alloc_frame();
				uint8_t *buf;
				int numbytes = avpicture_get_size(PIX_FMT_RGB24,  m_format.size.width, m_format.size.height);
				buf = (uint8_t *)av_malloc(numbytes * sizeof(uint8_t));
				int sz = avpicture_fill((AVPicture *)pFrameRGB, buf, PIX_FMT_RGB24, m_format.size.width, m_format.size.height);
				sz = avpicture_fill((AVPicture *)pFrame, m_returned_buffer->data, PIX_FMT_YUYV422, m_format.size.width, m_format.size.height);
		//				cout << "Size in bytes " << sz << endl;
				//int k = img_convert((AVPicture *)pFrameRGB, PIX_FMT_RGB24, (AVPicture *)pFrame, PIX_FMT_YUYV422, m_format.size.width, m_format.size.height);
				//cout << k << endl;		

				//sz = avpicture_fill((AVPicture *)pFrameRGB, m_returned_buffer->data, PIX FMT YUYV422, m_format.size.width, m_format.size.height);
				if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER))
				{
				  fprintf(stderr, "Could not initialize SDL - %s\n", SDL_GetError());
				  exit(1);
				}
				SDL_Surface *screen;
				screen = SDL_SetVideoMode(m_format.size.width, m_format.size.height, 0, 0);
				if(!screen) {
				  fprintf(stderr, "SDL: could not set video mode - exiting\n");
				  exit(1);
				}


				SDL_Overlay     *bmp;
				bmp = SDL_CreateYUVOverlay(m_format.size.width, m_format.size.height,SDL_YV12_OVERLAY, screen);

				SDL_LockYUVOverlay(bmp);

				    AVPicture pict;
				    pict.data[0] = bmp->pixels[0];
				    pict.data[1] = bmp->pixels[2];
				    pict.data[2] = bmp->pixels[1];

				    pict.linesize[0] = bmp->pitches[0];
				    pict.linesize[1] = bmp->pitches[2];
				    pict.linesize[2] = bmp->pitches[1];

				    // Convert the image into YUV format that SDL uses
				    img_convert(&pict, PIX_FMT_YUV420P,(AVPicture *)pFrame,  PIX_FMT_YUYV422, m_format.size.width, m_format.size.height);
				    
				    SDL_UnlockYUVOverlay(bmp);

				rect.x = 0;
				rect.y = 0;
				rect.w = 240;//m_format.size.width;
				rect.h = 320; //m_format.size.height;
				SDL_DisplayYUVOverlay(bmp, &rect);
			}

#endif
		
			
			unicap_queue_buffer(m_handle, m_returned_buffer);
			do
			{
				gettimeofday(&present, NULL);
				ts_fps = (present.tv_sec * 1000000 + present.tv_usec) - (prev.tv_sec * 1000000 + prev.tv_usec)	;	
			
		
			}while(ts_fps < (1000000/fps));
		

		}
		pthread_mutex_unlock( &g_CapBuffer );
		frame++;
		pthread_mutex_lock( m_capstatus_mutex );

	}
	pthread_mutex_unlock( m_capstatus_mutex );
	

	stop_capture();


	pthread_mutex_lock( m_thrstop_mutex );
	pthread_cond_signal( m_thrstop_cond);
	pthread_mutex_unlock( m_thrstop_mutex );

};
void CUnicapVidCap::stop_capture()
{

	m_Cam->closeCamHandle(m_device_no);
	cout << "capture stopped successfully" << endl;

};

	





















