#ifndef INCLUDE_UNICAPVIDCAP_H
#define INCLUDE_UNICAPVIDCAP_H
#include <unicap.h>
#include <unicap_status.h>
#include "interfaces.h"
//#include "common_defines.h"


class CCameraDevice
{
public:
	static CCameraDevice* Instance();
	
	CCameraDevice();
	virtual ~CCameraDevice();
	int getNumberofCams();
	int getCamHandle(unicap_handle_t *handle, int device_no = 0);
	int closeCamHandle(int device_no);
	void destroy();
	int setformats(int device_no, unicap_format_t *format);
	int start_capture(int device_no);
	void stop_capture();
	int initCamera();
	void deinitCams();
	static CCameraDevice* m_CameraInstance;
	int m_refCount;
private:
	int m_NumCams;	
	unicap_data_buffer_t **m_buffers;

	int *m_start_capture;
	int *m_hndRefCount;	
	unicap_handle_t *m_handle;
	unicap_device_t *m_device;
	unicap_format_t *m_format_spec;
	unicap_format_t *m_format;

};

class CUnicapVidCap
{
public :
	//~CUnicapVidCap(){};
//	static CUnicapVidCap* Instance(IVideoCapture *, int threadid);
	CUnicapVidCap(IVideoCapture *, int streamid);
	virtual ~CUnicapVidCap();	

//	void destroy();
	void open_device(int device_no);
	int enumerate_devices();
	void setformats();
	void start_capture(int *stop_status, int fps);
	void stop_capture(); 

	pthread_mutex_t *m_capstatus_mutex;
	pthread_mutex_t *m_thrstop_mutex;
	pthread_cond_t *m_thrstop_cond;
	int m_threadid;	

	
private :
	int m_device_no;
	unicap_handle_t m_handle;
	unicap_device_t m_device;
	unicap_format_t m_format_spec;
	unicap_format_t m_format;
	unicap_data_buffer_t m_buffers[BUFFERS];
	unicap_data_buffer_t *m_returned_buffer;
	
	//static CUnicapVidCap* m_instance; 
	int m_PixFmt;
	
	CCameraDevice *m_Cam;
	IVideoCapture *BaseVidCapture;
};
#endif
